# ####################################################################
# Add an eckd device as an ensemble storage resource,
#     Then,  add it as a virtualization-host storage resource,
#          Then, add it to a storage group for the virtualization-host
#
# NOTE THAT THE VOLUME MUST NOT BE ATTACHED TO SYSTEM IN ORDER
#      FOR THE ADD VOLUME TO STORAGE GROUP TO WORK.
#      IF THE VOLUME IS ATTACHED TO SYSTEM, THEN THE ADD VOLUME TO
#      STORAGE GROUP STEP WILL RETURN:
#      post status 503 post reason Service Unavailable
# 
# Notes: MAT
# ####################################################################
import sys, httplib, urllib, json

# argv[0] is the script source
if len(sys.argv) != 11:
   print "usage:"
   print "  addeckd.py <ip> <hmc-user> <password> <nodename> <hiper-name> <storage-resource-name> <size> <description> <devnum> <volser>"
   print "example: addeckd.py 9.12.16.236 ensadmin password P95 VML2 XXB712 65000 XXB712-ECKD-DASD B712 XXB712"
   exit()
# use the command line arguments for the params (note: no further error checking being done)
else:
   host = str(sys.argv[1])
   port = 6794
   ensuser = str(sys.argv[2])
   enspw = str(sys.argv[3])
   nodename = str(sys.argv[4]) 
   hname = str(sys.argv[5])
   stgres = str(sys.argv[6])
   stgname = '$3390$'
   stgsize = int(sys.argv[7])
   stgdesc = str(sys.argv[8])
   devnum = str(sys.argv[9])
   volser = str(sys.argv[10])

print >>sys.stderr, "args:",host,ensuser,nodename,hname,stgres,stgsize,stgdesc,devnum,volser

# ##########################################################################
# Logon
# ##########################################################################
##print >>sys.stderr, "\nAttempting LOGIN:"

headers = {"Content-type":"application/json","Accept":"*/*"}

body = json.dumps({"userid":ensuser,"password":enspw})

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", "/api/session",body,headers)
response = conn.getresponse()
##print >>sys.stderr, "login status:  ", response.status
##print >>sys.stderr, "login reason:  ", response.reason
##print >>sys.stderr, "login headers: ", response.getheaders()
##print >>sys.stderr, "login body:    ", response.read()

# this session header is important.
apiSessionHeader = response.getheader( "X-API-Session" );
# print >>sys.stderr, "session header:", apiSessionHeader

# ##########################################################################
# Query for Ensemble ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", "/api/ensembles", "", headers)
response = conn.getresponse()
##print >>sys.stderr, "post status", response.status, "post reason", response.reason
mystuff = json.loads(response.read())
##print >>sys.stderr, "body:", mystuff
##print >>sys.stderr


# try to get parameter value from target
if len(mystuff) == 1:
##   print >>sys.stderr, "length of mystuff is 1", mystuff
#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
##   print >>sys.stderr, "length of mystuff is not 1", mystuff
#      # we already got our object; pack it in a list
#      # so we can handle both cases in same way
   mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:
##   print json.dumps(y.get("object-uri"),sort_keys=True, indent=4)
   ensembleid = y.get("object-uri")
   print >>sys.stderr, "Here is the ensemble ID for ", hname
   print >>sys.stderr, "  ", ensembleid
##print >>sys.stderr, "Done with for y in mylist loop"

#   print json.dumps(y.get(object-uri))

# ##########################################################################
# Query for NODE ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", ensembleid + "/nodes", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:
#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
      mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:
   if y.get("name") == nodename:
      nodeid = y.get("element-uri")
      print >>sys.stderr, "Here is the Node ID (element-uri) for ", nodename
      print >>sys.stderr, "  ", nodeid

# ##########################################################################
# Query for member from NODE properties
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodeid, "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:

#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

#      # we already got our object; pack it in a list
#      # so we can handle both cases in same way
   mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:

    nodemember = y.get("member")
    print >>sys.stderr, "Here is the MemberID (member) for ", nodename
    print >>sys.stderr, "  ", nodemember

# ##########################################################################
# Query for virtualization-hosts ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodemember + "/virtualization-hosts", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

## try to get parameter value from target
if len(mystuff) == 1:

   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   if y.get("name") == hname:
      hiperid = y.get("object-uri")
      print >>sys.stderr, "Here is the virtualization-host ID (object-uri) for ", hname
      print >>sys.stderr, "  ", hiperid
   
#### ##########################################################################
#### Query for the ID for the $3390$ storage group
#### COMMENTING OUT THIS ROUTINE - TURNS OUT WE DON'T SEEM TO NEED THIS - ####
#### ##########################################################################

##### Notice that there is a session header provided here so it takes advantage of the previous
##### logon code. 
####headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

####conn = httplib.HTTPSConnection(host,port)

####conn.request("GET", hiperid + "/virtualization-host-storage-groups", "", headers)
####response = conn.getresponse()
####print >>sys.stderr, "post status", response.status, "post reason", response.reason
####mystuff = json.loads(response.read())
####print >>sys.stderr, "body:", mystuff
####print >>sys.stderr

###### try to get parameter value from target
####if len(mystuff) == 1:
####   for x in mystuff: 
####      mylist = mystuff[x]
####else:
####   mylist = [ mystuff ]
####   # now go through the list and print the selected item
####for y in mylist:
####   if y.get("name") == stgname:
####      stgid = y.get("element-uri")
####      print >>sys.stderr, "Here is the storage group ID (element-uri) for ", stgname
####      print >>sys.stderr, "  ", stgid
#####   else:
#####      # don't do anything

###########################################################################
#### SET POST BODY TO ADD STORAGE RESOURCE
###########################################################################

request_body = json.dumps({"description":stgdesc,"type":"eckd","name":stgres,"size":stgsize})

##print >>sys.stderr, "request_body: ", request_body

# ##########################################################################
# POST TO ADD STORAGE RESOURCE
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

print >>sys.stderr, "\nAttempting POST to add storage resource:"

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", ensembleid + "/storage-resources", request_body, headers)

response = conn.getresponse()
print >>sys.stderr, "post status", response.status, "post reason", response.reason

mydata = response.read()

##print >>sys.stderr, "mydata: ", mydata
##print >>sys.stderr

########################################################################################
#### SAVE THE STORAGE RESOURCE ID THAT COMES IN THE RESPONSE - USING STRING OPERATIONS
#########################################################################################

slashstart = mydata.find('/')
stgresid = mydata[slashstart:-2] 

print >>sys.stderr, "Here is the Storage Resource ID :"
print >>sys.stderr,stgresid

###########################################################################
#### SET POST BODY TO ADD STORAGE RESOURCE TO VIRTUALIZATION HOST
###########################################################################

request_body = json.dumps({"storage-resource":stgresid,"device-number":devnum,"volume-serial-number":volser})

##print >>sys.stderr, "request_body: ", request_body


###########################################################################
#### DO THE POST TO ADD STORAGE RESOURCE TO VIRTUALIZATION HOST
###########################################################################
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

print >>sys.stderr, "\nAttempting POST to add storage resource to virtualization host:"

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", hiperid + "/virtualization-host-storage-resources", request_body, headers)

response = conn.getresponse()
print >>sys.stderr, "post status", response.status, "post reason", response.reason

mydata = response.read()

##print >>sys.stderr, "mydata: ", mydata
##print >>sys.stderr

###########################################################################################################
#### SAVE THE VIRTUALIZATION HOST STORAGE RESOURCE ID THAT COMES IN THE RESPONSE - USING STRING OPERATIONS
###########################################################################################################

slashstart = mydata.find('/')
vhoststgresid = mydata[slashstart:-2] 

print >>sys.stderr, "Here is the Virtualization Host Storage Resource ID :"
print >>sys.stderr,vhoststgresid

###########################################################################################
#### SET POST BODY TO ADD VIRTUALIZATION HOST STORAGE RESOURCE TO STORAGE GROUP $3390$
#### DON'T EVEN HAVE TO TELL IT $3390$ - IT KNOWS 
###########################################################################################

request_body = json.dumps({"virtualization-host-storage-resource":vhoststgresid})

##print >>sys.stderr, "request_body: ", request_body

########################################################################################
#### DO THE POST TO ADD THE VIRTUALIZATION HOST STORAGE RESOURCE TO STORAGE GROUP $3390$
########################################################################################
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

print >>sys.stderr, "\nAttempting POST to add virtualization host storage resource to storage group $3390$"

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", hiperid + "/operations/add-virtualization-host-storage-resource-to-group", request_body, headers)

response = conn.getresponse()
print >>sys.stderr, "post status", response.status, "post reason", response.reason


mystuff = json.loads(response.read())
##print >>sys.stderr, "body:", mystuff

# ##########################################################################
# Now we'll logoff
# ##########################################################################
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}
print >>sys.stderr, "\nAttempting LOGOFF:"

conn = httplib.HTTPSConnection(host,port)

conn.request("DELETE", "/api/session/this-session","",headers)
response = conn.getresponse()
##print >>sys.stderr, "delete status", response.status, "delete reason", response.reason
##print >>sys.stderr, "body:", response.read()

