# ##################################################
# Add a dedicated OSX or IQDX NIC
# 9/14/12 Has uppercase updates and iqdx updates
# 2/11/13 using an array for the networks - MAT
# ##################################################
import sys, httplib, urllib, json

# argv[0] is the script source
if (len(sys.argv) < 11) or (len(sys.argv) > 27):
   print "usage:"
   print "addnic-dedicate.py <ip> <hmc-user> <password> <nodename> <hiper-name> <virtual-server-name> <virt-devno> <real-devno> <chpid> <osx or iqdx> <network1-name> <network2-name> <networkn-name>  "
   print "example: addnic-dedicate.py 9.12.16.241 ensadmin password P93 VML1 GSSF44 280 288 38 osx 10.20.28-z/VM_DMZ2"
   print " or:      "
   print "example: addnic-dedicate.py 9.12.16.241 ensadmin password P93 VML1 GSSF44 280 288 38 osx 10.20.28-z/VM_DMZ2 10.20.27-zVM_IEDN2_Secure"
   print " or:      "
   print "example: addnic-dedicate.py 9.12.16.241 ensadmin password P93 VML1 GSSF34 e414 e414 E4 iqdx 10.20.27-zVM_IEDN2_Secure"
   print "          "
   print "From 0 to 16 networks can be specified"
   exit()
# use the command line arguments for the params (note: no further error checking being done)

osxiqdx = str(sys.argv[10])
if (osxiqdx != 'osx') and (osxiqdx != 'iqdx'):
   print "usage:"
   print "addnic-dedicate.py <ip> <hmc-user> <password> <nodename> <hiper-name> <virtual-server-name> <virt-devno> <real-devno> <chpid> <osx or iqdx> <network1-name> <network2-name> <networkn-name>  "
   print "example: addnic-dedicate.py 9.12.16.241 ensadmin password P93 VML1 GSSF44 280 288 38 osx 10.20.28-z/VM_DMZ2"
   print " or:      "
   print "example: addnic-dedicate.py 9.12.16.241 ensadmin password P93 VML1 GSSF44 280 288 38 osx 10.20.28-z/VM_DMZ2 10.20.27-zVM_IEDN2_Secure"
   print " or:      "
   print "example: addnic-dedicate.py 9.12.16.241 ensadmin password P93 VML1 GSSF34 e414 e414 E4 iqdx 10.20.27-zVM_IEDN2_Secure"
   exit()

host = str(sys.argv[1])
port = 6794
ensuser = str(sys.argv[2])
enspw = str(sys.argv[3]) 
nodename = str(sys.argv[4])
hname = str(sys.argv[5])
vname = str(sys.argv[6])
vdevnum = str(sys.argv[7])
rdevnum = str(sys.argv[8])
chpidnum = str(sys.argv[9])

print >>sys.stderr, "Adding an " + osxiqdx + " NIC to VHOST " + vname + " in Hipervisor: " + hname + " on Node: " + nodename + " on virtual dev " + vdevnum + " on real dev " + rdevnum + " using chpid " + chpidnum + " on specified networks. Interface-type is physical-iedn"
print >>sys.stderr, "                                                                        "
print >>sys.stderr, "Success returns: post status 201 post reason Created"
print >>sys.stderr, "                                                    "    

################################
####### Setup Network counters
################################
netnum = (len(sys.argv) - 11)
netspot = 11

# #############################################################################
# Convert the device numbers & chpid to upper - but iqdx or osx has to be lower
# #############################################################################

chpidup = chpidnum.upper()
vdevup = vdevnum.upper()
rdevup = rdevnum.upper()
osxiqdxlow = osxiqdx.lower()

##print >>sys.stderr, "chpidup ",chpidup
##print >>sys.stderr, "vdevup ",vdevup
##print >>sys.stderr, "rdevup ",rdevup
##print >>sys.stderr, "osxiqdxup ",osxiqdx

chpidnum = chpidup
vdevnum = vdevup
rdevnum = rdevup
osxiqdx = osxiqdxlow

##print >>sys.stderr, "chpidnum ",chpidnum
##print >>sys.stderr, "vdevnum ",vdevnum
##print >>sys.stderr, "rdevnum ",rdevnum
##print >>sys.stderr, "osxiqdx ",osxiqdx

# ##########################################################################
# Logon
# ##########################################################################

headers = {"Content-type":"application/json","Accept":"*/*"}
# Login credentials live in body 
body = json.dumps({"userid":ensuser,"password":enspw})

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", "/api/session",body,headers)
response = conn.getresponse()

# this session header is important.
apiSessionHeader = response.getheader( "X-API-Session" );
# print >>sys.stderr, "session header:", apiSessionHeader

# ##########################################################################
# Query for Ensemble ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", "/api/ensembles", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:
   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:
   ensembleid = y.get("object-uri")
   print >>sys.stderr, "Here is the ensemble ID for ", hname
   print >>sys.stderr, "  ", ensembleid

# ##########################################################################
# Query for NODE ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", ensembleid + "/nodes", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:
#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
      mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:
   if y.get("name") == nodename:
      nodeid = y.get("element-uri")
      print >>sys.stderr, "Here is the Node ID (element-uri) for ", nodename
      print >>sys.stderr, "  ", nodeid

# ##########################################################################
# Query for member from NODE properties
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodeid, "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:

#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

#      # we already got our object; pack it in a list
#      # so we can handle both cases in same way
   mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:

    nodemember = y.get("member")
    print >>sys.stderr, "Here is the MemberID (member) for ", nodename
    print >>sys.stderr, "  ", nodemember


# ##########################################################################
# Query for virtualization-hosts ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodemember + "/virtualization-hosts", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

## try to get parameter value from target
if len(mystuff) == 1:

   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   if y.get("name") == hname:
      hiperid = y.get("object-uri")
      print >>sys.stderr, "Here is the virtualization-host ID (object-uri) for ", hname
      print >>sys.stderr, "  ", hiperid

   
# ##########################################################################
# Query for virtual server ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", hiperid + "/virtual-servers", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

## try to get parameter value from target
if len(mystuff) == 1:

   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   if y.get("name") == vname:

      vsid = y.get("object-uri")
      print >>sys.stderr, "Here is the virtual-server ID (object-uri) for ", vname
      print >>sys.stderr, "  ", vsid

# ###############################################################################
# Query for virtual server ID of the LPAR Virtual Server - using nodename (CPC)
# ###############################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodemember + "/virtual-servers", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

## try to get parameter value from target
if len(mystuff) == 1:
   ###   print >>sys.stderr, "length of mystuff is 1", mystuff 
   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
       
else:

   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   ###   print >>sys.stderr, "length of mystuff not 1", mystuff
   mylist = [ mystuff ]
   ###   print json.dumps(mylist,sort_keys=True, indent=4)
   # now go through the list and print the selected item
for y in mylist:

   if y.get("name") == hname:

      prsmvsid = y.get("object-uri")
      print >>sys.stderr, "Here is the virtual-server ID (object-uri) for the Virtual Server object for ", hname
      print >>sys.stderr, "  ", prsmvsid
      htype = y.get("type")
      print >>sys.stderr, "Here is the Type (type) for the Virtual Server object for ", hname
      print >>sys.stderr, "  ", htype

# ##########################################################################
# Query for the virtual server properties of the PRSM virtual server 
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", prsmvsid, "", headers)
response = conn.getresponse()

###debug print >>sys.stderr, "post status", response.status, "post reason", response.reason
mystuff = json.loads(response.read())
###debug print >>sys.stderr, "body:", mystuff
###debug print >>sys.stderr

## try to get parameter value from target
if len(mystuff) == 1:
   ###debug   print >>sys.stderr, "length of mystuff is 1", mystuff
   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
   ###debug print >>sys.stderr, "length of mystuff is not 1", mystuff
   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   myadapters = y.get("network-adapters")

###   print >>sys.stderr, "                              "
###   print >>sys.stderr, "Here are the Network Adapters:"
###   print >>sys.stderr, "                              "
###   print >>sys.stderr, myadapters

for z in myadapters:

   if z.get("chpid") == chpidnum:

      adapturi = z.get("element-uri")
      print >>sys.stderr, "Here is the element-uri for the network adapter for chpid: ", chpidnum
      print >>sys.stderr, " ", adapturi
########################################################################
#####  DEBUG B1782
########################################################################
      if osxiqdx == 'iqdx' :
         print >>sys.stderr, "                                                   "
         print >>sys.stderr, " workaround for B1782: If this is an iqdx request  "
         print >>sys.stderr, " Change OSX to IQDX in the adapturi field      "
         adapturix = adapturi.replace("OSX","IQDX")
         print >>sys.stderr, "                                               "
         adapturi = adapturix
         print >>sys.stderr, " The new adapturi string is: ", adapturi 
      
      
###      print >>sys.stderr, "But, we are going to hardcode the value to use IQDX instead of OSX like so: "
###      adapturi = "/api/virtual-servers/776b6eea-79cb-11e1-abf9-f0def1cb6750/network-adapters/IQDX%201.E4"
###      print >>sys.stderr, " ", adapturi

##########################################################################
#  Network processing
##########################################################################
print >>sys.stderr, "Processing networks.  The number of networks is: "
print >>sys.stderr, netnum
##
## Initialize our list - 
vnetarray = ["1"] * netnum
##
for i in range(0,netnum):
   vnetname = str(sys.argv[netspot])
   print >>sys.stderr, "Processing network " + vnetname
   netspot = netspot + 1


###########################################################################
# Query for virtual network ID
###########################################################################


# ##########################################################################
# Query for virtual network ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
   headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

   conn = httplib.HTTPSConnection(host,port)

   conn.request("GET", ensembleid + "/virtual-networks", "", headers)
   response = conn.getresponse()

   mystuff = json.loads(response.read())

   ## try to get parameter value from target
   if len(mystuff) == 1:
   
      # then we have a list nested in here somewhere
      # and have to dig deeper to get the list of objects
      for x in mystuff: 
         mylist = mystuff[x]
   else:
   
      # we already got our object; pack it in a list
      # so we can handle both cases in same way
      mylist = [ mystuff ]
      # now go through the list and print the selected item
   for y in mylist:

      if y.get("name") == vnetname:

         vneturi = y.get("object-uri")
         print >>sys.stderr, "Here is the virtual-network ID (object-uri) for ", vnetname
         print >>sys.stderr, "  ", vneturi

   # Take the vneturi and put it in the vnetarray
   vnetarray[i] = vneturi       

###########################################################################
#### SET POST BODY
###########################################################################

request_body = json.dumps({"virtual-device-address":vdevnum,"real-device-address":rdevnum,"type":osxiqdx,"interface-type":"physical-iedn","switch-uri":adapturi,"network-uris":vnetarray})

print >>sys.stderr, "request_body: ", request_body

# ##########################################################################
# POST TO ADD ADAPTER
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

print >>sys.stderr, "\nAttempting POST to add nic:"

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", vsid + "/network-adapters", request_body, headers)

response = conn.getresponse()
print >>sys.stderr, "post status", response.status, "post reason", response.reason
mystuff = json.loads(response.read())
print >>sys.stderr, "body:", mystuff
print >>sys.stderr



# ##########################################################################
# Now we'll logoff
# ##########################################################################
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}
##print >>sys.stderr, "\nAttempting LOGOFF:"

conn = httplib.HTTPSConnection(host,port)

conn.request("DELETE", "/api/session/this-session","",headers)
response = conn.getresponse()
##print >>sys.stderr, "delete status", response.status, "delete reason", response.reason
##print >>sys.stderr, "body:", response.read()

